#!/usr/bin/perl

use strict;
use warnings;


our ($dataset,$res_dir,$data_dir);
my $lib_file = "libS.pl";
require $lib_file;

open (SIM_FILE,$res_dir."/".$dataset."/string_similarities/LCS.csv")|| die $!;
open (GLD,$data_dir."/".$dataset.".train")|| die $!;#train actually, which includes all rules

#open (SIM_FILE,shift @ARGV)|| die $!;
#open (GLD,shift @ARGV)|| die $!;#train actually, which includes all rules


my %frag_is_in_rule;
while(my $line=<GLD>){
	chomp $line;
	my @items=split ",",$line;
	foreach my $i (1..$#items){
		$frag_is_in_rule{$items[$i]}=$items[0];
	}
}
close GLD;

my %class;# $class{$rule_name}{$frag_name}
while(my $line=<SIM_FILE>){
	chomp $line;
	my @items=split ",",$line;
	my $max=-1;
	my %max_rules;
	for(my $i=1;$i<$#items;$i+=2){
		if ($max<=$items[$i+1]){
			$max=$items[$i+1];
		}
	}
	for(my $i=1;$i<$#items;$i+=2){
		if ($items[$i+1]==$max){
			my $assoc_rule=$frag_is_in_rule{$items[$i]};
			$class{$assoc_rule}{$items[0]}=1;
		}
	}
}

foreach my $rule (keys %class){
	my @res;
	push @res,$rule;
	push @res,keys %{$class{$rule}};
	print join ",",@res;
	print "\n";
}



